#version 330

out vec2 texCoord0;
out vec3 normal0;
out vec3 worldPosition0;

layout (location = 0) in vec3 position;
layout (location = 1) in vec2 texCoord;
layout (location = 2) in vec3 normal;

uniform mat4 transform;
uniform mat4 transformProjected;

void main()
{
	texCoord0 = texCoord;
	normal0 = (transform * vec4(normal, 0.0)).xyz;
	worldPosition0 =  (transform * vec4(normal, 1.0)).xyz;
	gl_Position = transformProjected * vec4(position, 1.0);
}