package be.ikkeflikkeri.engine;

public class BasicShader extends Shader
{
	private static BasicShader shader = new BasicShader();
	
	public BasicShader()
	{
		super();
		
		addVertexShader(Shader.load("basic.vs"));
		addFragmentShader(Shader.load("basic.fs"));
		
		compile();
		
		addUniform("transform");
		addUniform("baseColor");
	}
	
	public static BasicShader getInstance()
	{
		return shader;
	}
	
	public void updateUniforms(Matrix4f worldMatrix, Matrix4f projectedMatrix, Material material)
	{
		if(material.getTexture() != null)
			material.getTexture().bind();
		else
			Renderer.unbindTextures();
		
		setUniform("transform", projectedMatrix);
		setUniform("baseColor", material.getColor());
	}
}
