package be.ikkeflikkeri.engine;

public class Camera
{
	private Vector3f position;
	private Vector3f forward;
	private Vector3f up;
	
	public Camera()
	{
		this(new Vector3f(0, 0, 0), new Vector3f(0, 0, 1), new Vector3f(0, 1, 0));
	}
	public Camera(Vector3f position, Vector3f forward, Vector3f up)
	{
		this.position = position;
		this.forward = forward.normalized();
		this.up = up.normalized();
	}

	public void move(Vector3f direction, float amount)
	{
		position = position.add(direction.multiply(amount));
	}
	
	public void rotateX(float angle)
	{
		Vector3f hAxis = getGlobalUp().cross(forward).normalized();
		
		forward = forward.rotate(angle, hAxis).normalized();
		up = forward.cross(hAxis).normalized();
	}
	
	public void rotateY(float angle)
	{
		Vector3f hAxis = getGlobalUp().cross(forward).normalized();
		
		forward = forward.rotate(angle, getGlobalUp()).normalized();
		up = forward.cross(hAxis).normalized();
	}
	
	public Vector3f getRight()
	{
		return forward.cross(up).normalized();
	}
	
	public Vector3f getLeft()
	{
		return up.cross(forward).normalized();
	}
	
	public Vector3f getPosition()
	{
		return position;
	}

	public void setPosition(Vector3f position)
	{
		this.position = position;
	}

	public Vector3f getForward()
	{
		return forward;
	}

	public void setForward(Vector3f forward)
	{
		this.forward = forward;
	}

	public Vector3f getUp()
	{
		return up;
	}

	public void setUp(Vector3f up)
	{
		this.up = up;
	}
	
	public Vector3f getGlobalUp()
	{
		return new Vector3f(0, 1, 0);
	}
}
