package be.ikkeflikkeri.engine;

import be.ikkeflikkeri.game.Game;

class Core
{
	private boolean isRunning;
	private Game game;
	
	public void start()
	{
		if(isRunning)
			return;
		
		game = new Game();
		isRunning = true;
		
		run();
	}
	
	public void stop()
	{
		if(!isRunning)
			return;
		
		isRunning = false;
	}
	
	private void run()
	{
		initialize();
		
		while(isRunning)
		{
			FPSHandler.update();
			
			while(FPSHandler.process())
			{
				input();
				update();
			}
			
			if(FPSHandler.render())
				render();
		}
		
		destroy();
	}
	
	private void initialize()
	{
		game.initialize();
	}
	
	private void input()
	{
		game.input();
	}
	
	private void update()
	{
		game.update();
	}
	
	private void render()
	{
		game.render();
	}
	
	private void destroy()
	{
		game.destoy();
	}
}
