package be.ikkeflikkeri.engine;

import java.nio.IntBuffer;
import java.util.ArrayList;
import java.util.List;

import org.lwjgl.BufferUtils;

public class IndexArray
{
	private List<Index> indices;
	
	public IndexArray()
	{
		indices = new ArrayList<Index>();
	}
	public IndexArray(Index[] indices)
	{
		this.indices = new ArrayList<Index>();

		add(indices);
	}
	
	public void add(Index index)
	{
		indices.add(index);
	}
	public void add(Index[] indices)
	{
		for(int i = 0; i < indices.length; i++)
		{
			this.indices.add(indices[i]);
		}
	}
	
	public Index get(int number)
	{
		return indices.get(number);
	}
	
	public IntBuffer toFloatBuffer()
	{
		IntBuffer buffer = BufferUtils.createIntBuffer(indices.size() * Index.SIZE);
		
		for(int i = 0; i < indices.size(); i++)
		{
			buffer.put(indices.get(i).getI1());
			buffer.put(indices.get(i).getI2());
			buffer.put(indices.get(i).getI3());
		}
		
		buffer.flip();
		
		return buffer;
	}
	
	public Index[] toArray()
	{
		return (Index[]) indices.toArray();
	}

	public int getSize()
	{
		return indices.size();
	}
}
