package be.ikkeflikkeri.engine;

import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;

public class Input
{
	private static boolean[] lastKeys = new boolean[Keys.NUM_KEYCODES];
	private static boolean[] lastMouse = new boolean[Keys.NUM_MOUSEBUTTONS];
	private static int mouseWheel = 0;
	private static boolean mouseGrabbed = false;
	
	public static void update()
	{
		for(int i = 0; i < Keys.NUM_KEYCODES; i++)
			lastKeys[i] = getKey(i);
		for(int i = 0; i < Keys.NUM_MOUSEBUTTONS; i++)
			lastMouse[i] = getMouse(i);
		
		mouseWheel = Mouse.getDWheel();
	}
	
	public static boolean getKey(int keycode)
	{
		return Keyboard.isKeyDown(keycode);
	}
	
	public static boolean getKeyDown(int keycode)
	{
		return getKey(keycode) && !lastKeys[keycode];
	}
	
	public static boolean getKeyUp(int keycode)
	{
		return !getKey(keycode) && lastKeys[keycode];
	}
	
	public static boolean getMouse(int button)
	{
		return Mouse.isButtonDown(button);
	}
	
	public static boolean getMouseDown(int button)
	{
		return getMouse(button) && !lastMouse[button];
	}
	
	public static boolean getMouseUp(int button)
	{
		return !getMouse(button) && lastMouse[button];
	}
	
	public static boolean getMouseWheelUp()
	{
		return (mouseWheel > 0);
	}
	
	public static boolean getMouseWheelDown()
	{
		return (mouseWheel < 0);
	}
	
	public static Vector2f getMousePosition()
	{
		return new Vector2f(Mouse.getX(), Mouse.getY());
	}
	
	public static void setMousePosition(Vector2f position)
	{
		Mouse.setCursorPosition((int)position.getX(), (int)position.getY());
	}
	
	public static void setCursorGrabbed(boolean enabled)
	{
		mouseGrabbed = enabled;
		Mouse.setGrabbed(enabled);
	}
	
	public static boolean getCursorGrabbed()
	{
		return mouseGrabbed;
	}
}
