package be.ikkeflikkeri.engine;

public class Vertex
{
	public static final int SIZE = 8;
	
	private Vector3f position;
	private Vector2f texCoord;
	private Vector3f normal;
	
	public Vertex()
	{
		this(new Vector3f(0, 0, 0), new Vector2f(0, 0));
	}
	public Vertex(Vector3f position)
	{
		this(position, new Vector2f(0, 0));
	}
	public Vertex(Vector3f position, Vector2f texCoord)
	{
		this(position, texCoord, new Vector3f(0, 0, 0));
	}
	public Vertex(Vector3f position, Vector2f texCoord, Vector3f normal)
	{
		this.position = position;
		this.texCoord = texCoord;
		this.setNormal(normal);
	}
	
	public void set(Vector3f position, Vector2f texCoord, Vector3f normal)
	{
		setPosition(position);
		setTexCoord(texCoord);
		setNormal(normal);
	}
	public Vector3f getPosition()
	{
		return position;
	}
	public void setPosition(Vector3f position)
	{
		this.position = position;
	}
	public Vector2f getTexCoord()
	{
		return texCoord;
	}
	public void setTexCoord(Vector2f texCoord)
	{
		this.texCoord = texCoord;
	}
	public Vector3f getNormal()
	{
		return normal;
	}
	public void setNormal(Vector3f normal)
	{
		this.normal = normal;
	}
}
