package be.ikkeflikkeri.engine;

import java.nio.FloatBuffer;
import java.util.ArrayList;
import java.util.List;

import org.lwjgl.BufferUtils;

public class VertexArray
{
	private List<Vertex> vertices;
	
	public VertexArray()
	{
		vertices = new ArrayList<Vertex>();
	}
	public VertexArray(Vertex[] vertices)
	{
		this.vertices = new ArrayList<Vertex>();
		
		add(vertices);
	}
	
	public void add(Vertex vertex)
	{
		vertices.add(vertex);
	}
	public void add(Vertex[] vertices)
	{
		for(int i = 0; i < vertices.length; i++)
		{
			this.vertices.add(vertices[i]);
		}
	}
	
	public Vertex get(int number)
	{
		return vertices.get(number);
	}
	public int getSize()
	{
		return vertices.size();
	}
	
	public FloatBuffer toFloatBuffer()
	{
		FloatBuffer buffer = BufferUtils.createFloatBuffer(vertices.size() * Vertex.SIZE);
		
		for(int i = 0; i < vertices.size(); i++)
		{
			buffer.put(vertices.get(i).getPosition().getX());
			buffer.put(vertices.get(i).getPosition().getY());
			buffer.put(vertices.get(i).getPosition().getZ());
			buffer.put(vertices.get(i).getTexCoord().getX());
			buffer.put(vertices.get(i).getTexCoord().getY());
			buffer.put(vertices.get(i).getNormal().getX());
			buffer.put(vertices.get(i).getNormal().getY());
			buffer.put(vertices.get(i).getNormal().getZ());
		}
		
		buffer.flip();
		
		return buffer;
	}
	
	public Vertex[] toArray()
	{
		return (Vertex[]) vertices.toArray();
	}
}
